package com.franckbarbier.nycp_java_se;

public class NYCP_Java_SE {

    public static void main(String[] args) {
        javax.persistence.EntityManagerFactory emf = javax.persistence.Persistence.createEntityManagerFactory("New_York_City_Penitentiary");
        javax.persistence.EntityManager em = emf.createEntityManager();

        for (Prisoner p : em.createNamedQuery("Prisoner.All_JPQL", Prisoner.class).getResultList()) {
            System.out.println("All: " + p);
        }
        System.out.println();

        for (Object o : em.createNamedQuery("Prisoner.Under_remand_SQL").getResultList()) {
            try {
                Object[] prisoner_properties = (Object[]) o;
                System.out.print("Under remand: - ");
                for (int i = 0; i < prisoner_properties.length; i++) {
                    System.out.print(prisoner_properties[i] + " - ");
                }
                System.out.println();
            } catch (ClassCastException cce) {
                // the type of 'o' is not 'Object[]', so?
            }
        }
        System.out.println();

        for (Prisoner p : em.createNamedQuery("Prisoner.Under_remand_JPQL", Prisoner.class).getResultList()) {
            System.out.println("Under remand: " + p);
        }
    }
}
